#include "hpscat.h"

_hcode  hcode;
_efont  efont;
_layout layout;
_cmode  cmode;
char    *nalza;
int     prows, fsize, width;
bool    to_stdout, nolnum, cont;

/**************
   initialize
 **************/

void
init(ac,av)
  int  *ac;
  char *av[];
{
    int  i;
    extern void setnalza(), read_rc();
    extern void usage PROT((char *));

    /*  set default parameters  */
    hcode  = KSC;
    efont  = Plain;
    fsize  = Defaultsize;
    layout = Garo;
    nolnum = False;
    to_stdout = True;
    cheat = False;
    narrow = True;

    read_rc();   /* read user's rc */

    /*  process command line arguments  */

    i = 1;
    while(av[i]) {
	if(av[i][0] == '-') {
	    if(!strcmp(av[i], "-f"))   to_stdout = False;
	    else if(!strcmp(av[i], "-l3")) layout = Garo3;
	    else if(!strcmp(av[i], "-l"))  goto next;
	    else if(!strcmp(av[i], "-p2")) layout = Sero2;
	    else if(!strcmp(av[i], "-p"))  layout = Sero;
	    else if(!strcmp(av[i], "-nl")) nolnum = True;
	    else if(!strcmp(av[i], "-ks")) goto next;
	    else if(!strcmp(av[i], "-N"))  hcode = Nbyte;
	    else if(!strcmp(av[i], "-16")) hcode = Johap;
	    else if(!strcmp(av[i], "-i"))  hcode = ISO;
	    else if(!strcmp(av[i], "-bf")) efont = Bold;
	    else if(!strcmp(av[i], "-nn")) narrow = False;
	    else if(!strcmp(av[i], "-cheat")) cheat = True;
	    else if(!strncmp(av[i], "-fs", 3)) {
		int a = atoi(av[i]+3);
		if(a<Smallest||a>Largest) fatal("invalid font size");
		fsize = a;
	    }
	    else usage(av[0]);
	  next:
	    { /* shifting arguments */
	        int j;
	        for(j=i; j<*ac; j++) av[j] = av[j+1];
	    }
	    (*ac)--;
	}
	else i++;
    }
    cont = False;
    switch(layout) {
      case Garo:  prows = L_height/fsize; width = L_width-S_width;  break;
      case Garo3: prows = L_height/fsize; width = L3_width-S_width; break;
      case Sero:  prows = P_height/fsize; width = P_width-S_width;  break;
      case Sero2: prows = P_height/fsize; width = P2_width-S_width; break;
    }
    setnalza();
}

void
setnalza()
{
    struct timeval  T;
    struct timezone tz;
    struct tm *Time;
    
    nalza = (char *)malloc(32);
    gettimeofday(&T, &tz);
    Time = (struct tm *) malloc(sizeof(struct tm));
    Time = localtime(&T.tv_sec);
    sprintf(nalza, "%d/%d/%d ,   %02d:%02d",
	    Time->tm_mon+1, Time->tm_mday, Time->tm_year,
	    Time->tm_hour,  Time->tm_min);
}

/***  EOF  ***/
