#include <errno.h>
#include "hpscat.h"

extern totalpages;
static converted;
char  *tmpfn;

void
convert(s)
  char *s;
{
    int  i;
    char *args[5];  /* for execvp */
    extern void execute PROT((char **));
#ifdef  HPS
    if(hcode==KSC) {
#else
    if(hcode==Johap) {
#endif
        converted = 0;
        return;
    }
    tmpfn = tempnam("/tmp", "hpscat");
    for(i=0; i<4; i++)
        args[i] = (char *)malloc(256);
    strcpy(args[0], Converter);
    strcpy(args[2], s);
    strcpy(args[3], tmpfn);
    args[4] = (char *) 0;
    switch(hcode) {
#ifdef  HPS
      case Johap: strcpy(args[1], fromJH); break;
#else
      case KSC:   strcpy(args[1], fromKS); break;
#endif
      case Nbyte: strcpy(args[1], fromN); break;
      case ISO:   strcpy(args[1], fromI); break;
    }
    execute(args);
    fclose(fp);
    fp = fopen(tmpfn,"r");
    converted = 1;
}

void
execute(args)
  char **args;
{
    int  pid, status;
    if((pid=fork()) < 0) {
         perror("fork");
         exit(1);
    }
    if(pid==0) {
        execvp(args[0], args);
        perror("execvp");
        exit(1);
    }
    while(wait(&status)!=pid);
}

void
endfile()
{
    fclose(fp);
    if(ofp!=stdout) fclose(ofp);
    if(converted) unlink(tmpfn);
    fprintf(stderr,"%2d page%c\n", pageno, (pageno<2)? ' ':'s');
    totalpages += pageno;
}

#define   U1    "\033[4m"  /* underline on  */
#define   U2    "\033[7m"  /* inverse   on  */
#define   U0    "\033[0m"  /* underline off */

char *ver = "1.3.1";

void
usage(prg)
  char *prg;
{
  fprintf(stderr,"\t\t\t     %shpscat v%s%s\n", U2, ver, U0);
  fprintf(stderr,"\t\t\t\t\t\tby jbkang@csone.kaist.ac.kr\n");
  fprintf(stderr," Usage :  %s [options] files ...\n\n", prg);
  fprintf(stderr,"    %slayout options  (default is -l)%s\n", U1, U0);
  fprintf(stderr,"\t-l, -l3 : landscape 2 columns, 3 columns\n");
  fprintf(stderr,"\t-p, -p2 : portrait  1 column,  2 columns\n");
  fprintf(stderr,"    %scode options    (default is -ks)%s\n", U1, U0);
  fprintf(stderr,"\t-ks, -N, -16, -i : ksc5601, N-byte, johap, iso2022-1 code\n");
  fprintf(stderr,"    %smisc options%s\n", U1, U0);
  fprintf(stderr,"\t-f  : output to `filename.ps'  (default is stdout)\n");
  fprintf(stderr,"\t-bf : use boldface english font\n");
  fprintf(stderr,"\t-fs#: set font size [%d~%d]  (default is -fs%d)\n",
  	Smallest, Largest, Defaultsize);
  fprintf(stderr,"\t-nl : don't print outline box & line number\n");
  fprintf(stderr,"\t-nn : don't use 1:2 font width proportion (not narrowed)\n");
  fprintf(stderr,"\t-cheat : don't print actually, just count pages\n\n");
  fprintf(stderr,"    options can be set in ~/.hpscatrc in the form \"name = value\"\n");
  fprintf(stderr,"\t\tnames can be : layout, code, bold, narrow, size\n");
  fprintf(stderr,"\t\tvalues can be : l, l3, p, p2 (for layout)\n");
  fprintf(stderr,"\t\t                ks, N, 16, i (for code)\n");
  fprintf(stderr,"\t\t                true, false  (for bold and narrow)\n");
  fprintf(stderr,"\t\t                number       (for size)\n");
  exit(0);
}

void
fatal(s)
  char *s;
{
    fprintf(stderr,"? %s\n", s);
    exit(1);
}

/***  EOF  ***/
