#include "hpscat.h"
#include "ps.h"

extern aline pagebuf[Maxline];

/**************************
   make PostScript output
     (from page buffer)
 **************************/

void
showbuf(lm)
  int  lm;
{
    int  i, top = (layout==Sero || layout==Sero2) ?  P_TM : L_TM;
    extern void showline PROT((char *));

    if(cheat) return;
    moveto(lm, top-fsize-1);

    for(i=0; i<prows; i++) {
	char  ns[6];
	if(pagebuf[i].linenum == -1)  /*  EOF  */
	    return;
	else if(pagebuf[i].linenum && !nolnum)
	    sprintf(ns,"%5d",pagebuf[i].linenum);  /*  normal line  */
	else
	    strcpy(ns,"     ");      /*  continued line  */
	fprintf(ofp,"N (%s )S E ", ns);
	showline(pagebuf[i].line);
	moveto(lm, (top-fsize-1)-(i+1)*fsize);
    }
}

#ifdef HPS  /* hangul PS printer */

void
showline(s)
  char  *s;
{
    int  i=0;

    cmode = English;
    fprintf(ofp,"(");
    while(s[i]) {
	if(s[i]&0x80) {
	    if(cmode==English) {
		cmode = Korean;
	        fprintf(ofp,")S H (");
	    }
	    fprintf(ofp,"%c%c", s[i], s[i+1]);
	    i += 2;
	}
	else {
	    if(cmode==Korean) {
		cmode = English;
		fprintf(ofp,")S E (");
	    }
	    fputc(s[i],ofp);
  	    i++;
	}
    }
    fprintf(ofp,")S\n");
}

#else    /* not hangul PS printer */

/* -1 code stands for fill code */

static int fcode[] = { 0, -1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 
	   12, 13, 14, 15, 16, 17, 18, 19, 20 };
static int mcode[] = { 0, 0, -1, 1, 2, 3, 4, 5, 0, 0, 6, 7, 8, 9, 10, 11,
	   0, 0, 12, 13, 14, 15, 16, 17, 0, 0, 18, 19, 20, 21 };
static int lcode[] = { 0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10,
     11, 12, 13, 14, 15, 16, 0, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27 };

static int fjaso[] = {
    0x10, 0x11, 0x12, 0x14, 0x16,  0x19, 0x1a, 0x1b, 0x1c, 0x1d,
    0x1e, 0x1f, 0x0f, 0x21, 0x22,  0x23, 0x24, 0x26, 0x28
};

static int mjaso[] = {
    0x29,      0x2a|0x80, 0x2a,      0x2b|0x80, 0x2b,  0, 0,
    0x2d|0x80, 0x2f,      0x32+0x80, 0x47,      0x49|0x80, 0x5d|0x80,  0, 0,
    0x4c|0x80, 0x4a,      0x62,      0x73|0x80, 0x89|0x80, 0x75|0x80,  0, 0,
    0x66,      0x4e,      0x4e|0x80, 0x33
};

void
showline(s)
  char  *s;
{
    int  i=0;
    int  code, f, m, l;
    int  set, fc, mc, lc, currset = -1;
    extern void putit PROT((int));

    cmode = English;
    fprintf(ofp,"(");
    while(s[i]) {
	if(s[i]&0x80) {
	    if(cmode==English) {
		cmode = Korean;
		currset = -1;
	    }
	    code = s[i] & 0xff;
	    code = code*256 + (s[++i] & 0xff);
	    f = (code / 1024) % 32;
	    m = (code / 32) % 32;
	    l =  code % 32;

	    /** added for jaso handling **/
	    if(mcode[m]==-1 && fcode[f]!=0) {
		if(currset!=1) {
		    set = currset = 1;
		    fprintf(ofp,")s H%d (", currset);
		}
		putit(fjaso[f-2]);
		fprintf(ofp,")S %d 0 rmoveto (", (int)((float)(fsize)*7.5/8.));
		i++; continue;
	    }
	    if(fcode[f]==-1 && mcode[m]!=0) {
		if(mjaso[m-3]) {
		    int  mm = mjaso[m-3];
		    if(mm > 127) {  /* set 2 */
			if(currset!=2) {
			    currset = set = 2;
			    fprintf(ofp,")S H%d (", currset);
			}
			mm -= 128;
		    }
		    else if(currset!=1 && mm < 128) { /* set 1 */
			currset = set = 1;
		        fprintf(ofp,")S H%d (", currset);
		    }
		    putit(mm);
		}
		i++; continue;
	    }
	    set = find_set(mcode[m]);
	    if(set > 2)
		fatal("find_set() : invalid number..maybe corrupted input?");
	    else if(set==0) {
		fprintf(stderr,"? strange hangul code...ignoring\n");
		i++;
		continue;
	    }
	    fc = find_f(fcode[f],mcode[m],lcode[l]);
	    mc = find_m(fcode[f],mcode[m],lcode[l]);
	    lc = find_l(fcode[f],mcode[m],lcode[l]);
	    if(set!=currset) {
		currset = set;
		fprintf(ofp,")S H%d (", currset);
	    }
	    putit(fc);
	    putit(mc);
	    if(lc)
		putit(lc);
	}
	else {
	    if(cmode==Korean) {
		cmode = English;
		fprintf(ofp,")S E (");
	    }
	    fputc(s[i],ofp);
	}
	i++;
    }
    fprintf(ofp,")S\n");
}

#endif  /* HPS */

void
putit(c)
  int  c;
{
    switch(c) {
      case '\\': fprintf(ofp,"\\\\"); break;
      case '(':  fprintf(ofp,"\\("); break;
      case ')':  fprintf(ofp,"\\)"); break;
      default:  fprintf(ofp,"\\%03o", c&0xff);
    }
}

/***********************
   draw decorative box
 ***********************/

void
teduri(fname)
  char *fname;
{
    int  x, y;

    if(cheat) return;

    if(layout==Garo || layout==Garo3)
	fprintf(ofp,"90 rotate 0 -600 translate ");
    fprintf(ofp,".9 1 scale\n");

    if(nolnum) return;
    if(layout==Sero) {
	box(P_LM, P_BM, P_width, P_height);
	fillbox(P_LM, P_BM, S_width, P_height);
	box(P_LM, P_BM, S_width, P_height);
    }
    else if(layout==Sero2) {
	box(P2_LM1, P2_BM, P2_width, P2_height);
	box(P2_LM2, P2_BM, P2_width, P2_height);
	fillbox(P2_LM1, P2_BM, S_width, P2_height);
	fillbox(P2_LM2, P2_BM, S_width, P2_height);
    }
    else if(layout==Garo){
	box(L_LM1, L_BM, L_width, L_height);
	box(L_LM2, L_BM, L_width, L_height);
	fillbox(L_LM1, L_BM, S_width, L_height);
	fillbox(L_LM2, L_BM, S_width, L_height);
    }
    else {    /*  Garo3  */
	box(L3_LM1, L3_BM, L3_width, L3_height);
	box(L3_LM2, L3_BM, L3_width, L3_height);
	box(L3_LM3, L3_BM, L3_width, L3_height);
	fillbox(L3_LM1, L3_BM, S_width, L3_height);
	fillbox(L3_LM2, L3_BM, S_width, L3_height);
	fillbox(L3_LM3, L3_BM, S_width, L3_height);
    }
    x = (layout==Sero||layout==Sero2) ?  P_LM : L_LM1;
    y = (layout==Sero||layout==Sero2) ?  P_TM : L_TM;
     setfont(NameFont1, 11);
     moveto(x+10, y+10);
    fprintf(ofp,"(filename)S ");
     setfont(NameFont2, 14);
     moveto(x+70, y+10);
    fprintf(ofp,"(%s) S\n", fname);

    x = (layout==Sero||layout==Sero2) ? 
	P_LM+P_width-100 : L_LM2+L_width-100;
     setfont(PageNoFont, 12);
     moveto(x, y+10);
    fprintf(ofp,"(page  %d)S\n", pageno);

    x -= 100;
    y = (layout==Sero||layout==Sero2) ?  P_BM-20 : L_BM-20;
     setfont(TimeFont, 11);
     moveto(x, y);
    fprintf(ofp,"(printed at  %s)S\n", nalza);

    x = (layout==Sero||layout==Sero2) ?  P_LM : L_LM1;
    y = (layout==Sero||layout==Sero2) ?  P_BM : L_BM;
     setfont(LogoFont, 9);
     fprintf(ofp,"gsave newpath %d %d M (HPSCAT 1.3) ", x+20, y-20);
     fprintf(ofp,"false charpath .1 L T grestore\n");
}    

/***  EOF  ***/
